// SimilarImagesByHistogram.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/core/core.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "ImageCompararor.h"
#include <sys/types.h>
#include <windows.h>
#include <errno.h>
#include <vector>
#include <string>
#include <iostream>

#include <stdio.h>
#include <windows.h>

using namespace cv;
using namespace std;

// get  all files in directory
void listFiles(const string dir_name,vector<string> &files)
{

    HANDLE      hnd;
    WIN32_FIND_DATA find;
    
   // sprintf(tmp,"%s/*.*",dir_name);


    if((hnd = FindFirstFile(dir_name.c_str(), &find)) == INVALID_HANDLE_VALUE)
    {
		printf("  !");
		return;
    }
    files.push_back(string(find.cFileName));
    while(FindNextFile(hnd, &find))
    {
		 files.push_back(string(find.cFileName));
		
    }
    FindClose(hnd);

}






 

int main(int argc, char* argv[])
{
	char buffer[MAX_PATH];
	int dwRet = GetCurrentDirectory(MAX_PATH, buffer);
	string  nameQueryImage=string(buffer)+string("\\query\\");

	
	if(argc < 2)
		nameQueryImage+=string("tshirt.jpg");
	else
	    nameQueryImage+=string(argv[1]);
	
	

	cv::Mat queryImage= imread(nameQueryImage,1);
	if( !queryImage.data ) // check if the image has been loaded properly
	{
		cout << "Error  opening query image " << nameQueryImage << endl;
		
		return -1;
	}
	else
	{

		cout << "Opening query image " << nameQueryImage << endl;

	}

	ImageComparator ic;
	ic.setReferenceImage(queryImage);

    map<int, string> sortFileNames;
   // map<int, int>::size_type i;
    typedef pair<int, string> pairSortFileNames;


	vector<string> files = vector<string>();
	
	string nameDataSetImageDirectory=string(buffer)+string("\\imagedataset\\*.jpg");
	listFiles(nameDataSetImageDirectory,files);

	cout << "Calculate distance between query image histogram and dataset image histogram  " << endl;

	for (unsigned int i = 0;i < files.size();i++) {
		string fullFileName= string(buffer)+string("\\imagedataset\\")+files[i];
		cv::Mat datasetImage= cv::imread(fullFileName);
		if( !datasetImage.data ) // check if the image has been loaded properly
		{
			cout << "Error  opening dataset image " << datasetImage << endl;
			return -1;
		}
		double difference=ic.compare(datasetImage);
	    cout << "File name " << files[i] <<  " Difference:   " << difference  << endl;
		sortFileNames.insert(pairSortFileNames((int)difference,files[i]));

	}

	  map <int, string> :: iterator sortFileNamesIter;
	cout << "Sort dataset images by distance between query image histogram and dataset image histogram  " << endl;

	for(sortFileNamesIter=sortFileNames.begin();sortFileNamesIter != sortFileNames.end();sortFileNamesIter++)
	{

			cout << "File name " << (*sortFileNamesIter).second <<  " Histogram difference:   " << (*sortFileNamesIter).first  << endl;

	}

	return 0;
}

